import { z } from 'zod';

declare const QueryInstructionsSchema: z.ZodObject<{
    with: z.ZodUnion<[z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>, z.ZodEffects<z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, Record<string, any>[], Record<string, any>[]>]>;
    where: z.ZodUnion<[z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, z.ZodAny]>;
    to: z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>;
    including: z.ZodArray<z.ZodString, "many">;
    excluding: z.ZodArray<z.ZodString, "many">;
    orderedBy: z.ZodOptional<z.ZodObject<{
        ascending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        descending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    }, "strip", z.ZodTypeAny, {
        ascending?: string[];
        descending?: string[];
    }, {
        ascending?: string[];
        descending?: string[];
    }>>;
    in: z.ZodString;
    before: z.ZodUnion<[z.ZodString, z.ZodNull]>;
    after: z.ZodUnion<[z.ZodString, z.ZodNull]>;
    limitedTo: z.ZodNumber;
}, "strip", z.ZodTypeAny, {
    with?: Record<string, any> | Record<string, any>[];
    where?: any;
    to?: Record<string, any>;
    including?: string[];
    excluding?: string[];
    orderedBy?: {
        ascending?: string[];
        descending?: string[];
    };
    in?: string;
    before?: string;
    after?: string;
    limitedTo?: number;
}, {
    with?: Record<string, any> | Record<string, any>[];
    where?: any;
    to?: Record<string, any>;
    including?: string[];
    excluding?: string[];
    orderedBy?: {
        ascending?: string[];
        descending?: string[];
    };
    in?: string;
    before?: string;
    after?: string;
    limitedTo?: number;
}>;
type FullQueryInstructions = z.infer<typeof QueryInstructionsSchema>;
declare const CountQueryInstructionsSchema: z.ZodObject<Omit<{
    with: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>, z.ZodEffects<z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, Record<string, any>[], Record<string, any>[]>]>>;
    where: z.ZodOptional<z.ZodUnion<[z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, z.ZodAny]>>;
    to: z.ZodOptional<z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>>;
    including: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    excluding: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    orderedBy: z.ZodOptional<z.ZodOptional<z.ZodObject<{
        ascending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        descending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    }, "strip", z.ZodTypeAny, {
        ascending?: string[];
        descending?: string[];
    }, {
        ascending?: string[];
        descending?: string[];
    }>>>;
    in: z.ZodOptional<z.ZodString>;
    before: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
    after: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
    limitedTo: z.ZodOptional<z.ZodNumber>;
}, "to">, "strip", z.ZodTypeAny, {
    with?: Record<string, any> | Record<string, any>[];
    where?: any;
    including?: string[];
    excluding?: string[];
    orderedBy?: {
        ascending?: string[];
        descending?: string[];
    };
    in?: string;
    before?: string;
    after?: string;
    limitedTo?: number;
}, {
    with?: Record<string, any> | Record<string, any>[];
    where?: any;
    including?: string[];
    excluding?: string[];
    orderedBy?: {
        ascending?: string[];
        descending?: string[];
    };
    in?: string;
    before?: string;
    after?: string;
    limitedTo?: number;
}>;
type CountQueryInstructions = z.infer<typeof CountQueryInstructionsSchema>;
declare const CountQuerySchema: z.ZodObject<{
    count: z.ZodRecord<z.ZodString, z.ZodNullable<z.ZodObject<Omit<{
        with: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>, z.ZodEffects<z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, Record<string, any>[], Record<string, any>[]>]>>;
        where: z.ZodOptional<z.ZodUnion<[z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, z.ZodAny]>>;
        to: z.ZodOptional<z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>>;
        including: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        excluding: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        orderedBy: z.ZodOptional<z.ZodOptional<z.ZodObject<{
            ascending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            descending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, "strip", z.ZodTypeAny, {
            ascending?: string[];
            descending?: string[];
        }, {
            ascending?: string[];
            descending?: string[];
        }>>>;
        in: z.ZodOptional<z.ZodString>;
        before: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
        after: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
        limitedTo: z.ZodOptional<z.ZodNumber>;
    }, "to">, "strip", z.ZodTypeAny, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>>>;
}, "strip", z.ZodTypeAny, {
    count?: Record<string, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>;
}, {
    count?: Record<string, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>;
}>;
type CountQuery = z.infer<typeof CountQuerySchema>;
declare const CreateQueryInstructionsSchema: z.ZodObject<{
    where: z.ZodOptional<z.ZodUnion<[z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, z.ZodAny]>>;
    including: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    excluding: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    orderedBy: z.ZodOptional<z.ZodOptional<z.ZodObject<{
        ascending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        descending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    }, "strip", z.ZodTypeAny, {
        ascending?: string[];
        descending?: string[];
    }, {
        ascending?: string[];
        descending?: string[];
    }>>>;
    in: z.ZodOptional<z.ZodString>;
    before: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
    after: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
    limitedTo: z.ZodOptional<z.ZodNumber>;
    with: z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>;
}, "strip", z.ZodTypeAny, {
    where?: any;
    including?: string[];
    excluding?: string[];
    orderedBy?: {
        ascending?: string[];
        descending?: string[];
    };
    in?: string;
    before?: string;
    after?: string;
    limitedTo?: number;
    with?: Record<string, any>;
}, {
    where?: any;
    including?: string[];
    excluding?: string[];
    orderedBy?: {
        ascending?: string[];
        descending?: string[];
    };
    in?: string;
    before?: string;
    after?: string;
    limitedTo?: number;
    with?: Record<string, any>;
}>;
type CreateQueryInstructions = z.infer<typeof CreateQueryInstructionsSchema>;
declare const CreateQuerySchema: z.ZodObject<{
    create: z.ZodRecord<z.ZodString, z.ZodObject<{
        where: z.ZodOptional<z.ZodUnion<[z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, z.ZodAny]>>;
        including: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        excluding: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        orderedBy: z.ZodOptional<z.ZodOptional<z.ZodObject<{
            ascending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            descending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, "strip", z.ZodTypeAny, {
            ascending?: string[];
            descending?: string[];
        }, {
            ascending?: string[];
            descending?: string[];
        }>>>;
        in: z.ZodOptional<z.ZodString>;
        before: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
        after: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
        limitedTo: z.ZodOptional<z.ZodNumber>;
        with: z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>;
    }, "strip", z.ZodTypeAny, {
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
        with?: Record<string, any>;
    }, {
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
        with?: Record<string, any>;
    }>>;
}, "strip", z.ZodTypeAny, {
    create?: Record<string, {
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
        with?: Record<string, any>;
    }>;
}, {
    create?: Record<string, {
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
        with?: Record<string, any>;
    }>;
}>;
type CreateQuery = z.infer<typeof CreateQuerySchema>;
declare const DropQueryInstructionsSchema: z.ZodObject<Omit<{
    with: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>, z.ZodEffects<z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, Record<string, any>[], Record<string, any>[]>]>>;
    where: z.ZodOptional<z.ZodUnion<[z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, z.ZodAny]>>;
    to: z.ZodOptional<z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>>;
    including: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    excluding: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    orderedBy: z.ZodOptional<z.ZodOptional<z.ZodObject<{
        ascending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        descending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    }, "strip", z.ZodTypeAny, {
        ascending?: string[];
        descending?: string[];
    }, {
        ascending?: string[];
        descending?: string[];
    }>>>;
    in: z.ZodOptional<z.ZodString>;
    before: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
    after: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
    limitedTo: z.ZodOptional<z.ZodNumber>;
}, "to">, "strip", z.ZodTypeAny, {
    with?: Record<string, any> | Record<string, any>[];
    where?: any;
    including?: string[];
    excluding?: string[];
    orderedBy?: {
        ascending?: string[];
        descending?: string[];
    };
    in?: string;
    before?: string;
    after?: string;
    limitedTo?: number;
}, {
    with?: Record<string, any> | Record<string, any>[];
    where?: any;
    including?: string[];
    excluding?: string[];
    orderedBy?: {
        ascending?: string[];
        descending?: string[];
    };
    in?: string;
    before?: string;
    after?: string;
    limitedTo?: number;
}>;
type DropQueryInstructions = z.infer<typeof DropQueryInstructionsSchema>;
declare const DropQuerySchema: z.ZodObject<{
    drop: z.ZodRecord<z.ZodString, z.ZodObject<Omit<{
        with: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>, z.ZodEffects<z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, Record<string, any>[], Record<string, any>[]>]>>;
        where: z.ZodOptional<z.ZodUnion<[z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, z.ZodAny]>>;
        to: z.ZodOptional<z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>>;
        including: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        excluding: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        orderedBy: z.ZodOptional<z.ZodOptional<z.ZodObject<{
            ascending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            descending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, "strip", z.ZodTypeAny, {
            ascending?: string[];
            descending?: string[];
        }, {
            ascending?: string[];
            descending?: string[];
        }>>>;
        in: z.ZodOptional<z.ZodString>;
        before: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
        after: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
        limitedTo: z.ZodOptional<z.ZodNumber>;
    }, "to">, "strip", z.ZodTypeAny, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>>;
}, "strip", z.ZodTypeAny, {
    drop?: Record<string, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>;
}, {
    drop?: Record<string, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>;
}>;
type DropQuery = z.infer<typeof DropQuerySchema>;
declare const GetQueryInstructionsSchema: z.ZodObject<Omit<{
    with: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>, z.ZodEffects<z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, Record<string, any>[], Record<string, any>[]>]>>;
    where: z.ZodOptional<z.ZodUnion<[z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, z.ZodAny]>>;
    to: z.ZodOptional<z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>>;
    including: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    excluding: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    orderedBy: z.ZodOptional<z.ZodOptional<z.ZodObject<{
        ascending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        descending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    }, "strip", z.ZodTypeAny, {
        ascending?: string[];
        descending?: string[];
    }, {
        ascending?: string[];
        descending?: string[];
    }>>>;
    in: z.ZodOptional<z.ZodString>;
    before: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
    after: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
    limitedTo: z.ZodOptional<z.ZodNumber>;
}, "to">, "strip", z.ZodTypeAny, {
    with?: Record<string, any> | Record<string, any>[];
    where?: any;
    including?: string[];
    excluding?: string[];
    orderedBy?: {
        ascending?: string[];
        descending?: string[];
    };
    in?: string;
    before?: string;
    after?: string;
    limitedTo?: number;
}, {
    with?: Record<string, any> | Record<string, any>[];
    where?: any;
    including?: string[];
    excluding?: string[];
    orderedBy?: {
        ascending?: string[];
        descending?: string[];
    };
    in?: string;
    before?: string;
    after?: string;
    limitedTo?: number;
}>;
type GetQueryInstructions = z.infer<typeof GetQueryInstructionsSchema>;
declare const GetQuerySchema: z.ZodObject<{
    get: z.ZodRecord<z.ZodString, z.ZodNullable<z.ZodObject<Omit<{
        with: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>, z.ZodEffects<z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, Record<string, any>[], Record<string, any>[]>]>>;
        where: z.ZodOptional<z.ZodUnion<[z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, z.ZodAny]>>;
        to: z.ZodOptional<z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>>;
        including: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        excluding: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        orderedBy: z.ZodOptional<z.ZodOptional<z.ZodObject<{
            ascending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            descending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, "strip", z.ZodTypeAny, {
            ascending?: string[];
            descending?: string[];
        }, {
            ascending?: string[];
            descending?: string[];
        }>>>;
        in: z.ZodOptional<z.ZodString>;
        before: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
        after: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
        limitedTo: z.ZodOptional<z.ZodNumber>;
    }, "to">, "strip", z.ZodTypeAny, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>>>;
}, "strip", z.ZodTypeAny, {
    get?: Record<string, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>;
}, {
    get?: Record<string, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>;
}>;
type GetQuery = z.infer<typeof GetQuerySchema>;
declare const SetQueryInstructionsSchema: z.ZodObject<{
    with: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>, z.ZodEffects<z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, Record<string, any>[], Record<string, any>[]>]>>;
    where: z.ZodOptional<z.ZodUnion<[z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, z.ZodAny]>>;
    including: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    excluding: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    orderedBy: z.ZodOptional<z.ZodOptional<z.ZodObject<{
        ascending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        descending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    }, "strip", z.ZodTypeAny, {
        ascending?: string[];
        descending?: string[];
    }, {
        ascending?: string[];
        descending?: string[];
    }>>>;
    in: z.ZodOptional<z.ZodString>;
    before: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
    after: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
    limitedTo: z.ZodOptional<z.ZodNumber>;
    to: z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>;
}, "strip", z.ZodTypeAny, {
    with?: Record<string, any> | Record<string, any>[];
    where?: any;
    including?: string[];
    excluding?: string[];
    orderedBy?: {
        ascending?: string[];
        descending?: string[];
    };
    in?: string;
    before?: string;
    after?: string;
    limitedTo?: number;
    to?: Record<string, any>;
}, {
    with?: Record<string, any> | Record<string, any>[];
    where?: any;
    including?: string[];
    excluding?: string[];
    orderedBy?: {
        ascending?: string[];
        descending?: string[];
    };
    in?: string;
    before?: string;
    after?: string;
    limitedTo?: number;
    to?: Record<string, any>;
}>;
type SetQueryInstructions = z.infer<typeof SetQueryInstructionsSchema>;
declare const SetQuerySchema: z.ZodObject<{
    set: z.ZodRecord<z.ZodString, z.ZodObject<{
        with: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>, z.ZodEffects<z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, Record<string, any>[], Record<string, any>[]>]>>;
        where: z.ZodOptional<z.ZodUnion<[z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, z.ZodAny]>>;
        including: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        excluding: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        orderedBy: z.ZodOptional<z.ZodOptional<z.ZodObject<{
            ascending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            descending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, "strip", z.ZodTypeAny, {
            ascending?: string[];
            descending?: string[];
        }, {
            ascending?: string[];
            descending?: string[];
        }>>>;
        in: z.ZodOptional<z.ZodString>;
        before: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
        after: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
        limitedTo: z.ZodOptional<z.ZodNumber>;
        to: z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>;
    }, "strip", z.ZodTypeAny, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
        to?: Record<string, any>;
    }, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
        to?: Record<string, any>;
    }>>;
}, "strip", z.ZodTypeAny, {
    set?: Record<string, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
        to?: Record<string, any>;
    }>;
}, {
    set?: Record<string, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
        to?: Record<string, any>;
    }>;
}>;
type SetQuery = z.infer<typeof SetQuerySchema>;
declare const QueryInstructionSchema: z.ZodUnion<[z.ZodLiteral<"with">, z.ZodLiteral<"where">, z.ZodLiteral<"to">, z.ZodLiteral<"including">, z.ZodLiteral<"excluding">, z.ZodLiteral<"orderedBy">, z.ZodLiteral<"in">, z.ZodLiteral<"before">, z.ZodLiteral<"after">, z.ZodLiteral<"limitedTo">, z.ZodLiteral<"orderedBy.ascending">, z.ZodLiteral<"orderedBy.descending">]>;
type QueryInstruction = z.infer<typeof QueryInstructionSchema>;
declare const QueryTypeEnum: z.ZodEnum<["get", "set", "drop", "create", "count"]>;
type QueryType = z.infer<typeof QueryTypeEnum>;
declare const QuerySchema: z.ZodObject<{
    count: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodNullable<z.ZodObject<Omit<{
        with: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>, z.ZodEffects<z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, Record<string, any>[], Record<string, any>[]>]>>;
        where: z.ZodOptional<z.ZodUnion<[z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, z.ZodAny]>>;
        to: z.ZodOptional<z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>>;
        including: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        excluding: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        orderedBy: z.ZodOptional<z.ZodOptional<z.ZodObject<{
            ascending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            descending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, "strip", z.ZodTypeAny, {
            ascending?: string[];
            descending?: string[];
        }, {
            ascending?: string[];
            descending?: string[];
        }>>>;
        in: z.ZodOptional<z.ZodString>;
        before: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
        after: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
        limitedTo: z.ZodOptional<z.ZodNumber>;
    }, "to">, "strip", z.ZodTypeAny, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>>>>;
    create: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodObject<{
        where: z.ZodOptional<z.ZodUnion<[z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, z.ZodAny]>>;
        including: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        excluding: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        orderedBy: z.ZodOptional<z.ZodOptional<z.ZodObject<{
            ascending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            descending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, "strip", z.ZodTypeAny, {
            ascending?: string[];
            descending?: string[];
        }, {
            ascending?: string[];
            descending?: string[];
        }>>>;
        in: z.ZodOptional<z.ZodString>;
        before: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
        after: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
        limitedTo: z.ZodOptional<z.ZodNumber>;
        with: z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>;
    }, "strip", z.ZodTypeAny, {
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
        with?: Record<string, any>;
    }, {
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
        with?: Record<string, any>;
    }>>>;
    drop: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodObject<Omit<{
        with: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>, z.ZodEffects<z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, Record<string, any>[], Record<string, any>[]>]>>;
        where: z.ZodOptional<z.ZodUnion<[z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, z.ZodAny]>>;
        to: z.ZodOptional<z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>>;
        including: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        excluding: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        orderedBy: z.ZodOptional<z.ZodOptional<z.ZodObject<{
            ascending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            descending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, "strip", z.ZodTypeAny, {
            ascending?: string[];
            descending?: string[];
        }, {
            ascending?: string[];
            descending?: string[];
        }>>>;
        in: z.ZodOptional<z.ZodString>;
        before: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
        after: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
        limitedTo: z.ZodOptional<z.ZodNumber>;
    }, "to">, "strip", z.ZodTypeAny, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>>>;
    get: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodNullable<z.ZodObject<Omit<{
        with: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>, z.ZodEffects<z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, Record<string, any>[], Record<string, any>[]>]>>;
        where: z.ZodOptional<z.ZodUnion<[z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, z.ZodAny]>>;
        to: z.ZodOptional<z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>>;
        including: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        excluding: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        orderedBy: z.ZodOptional<z.ZodOptional<z.ZodObject<{
            ascending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            descending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, "strip", z.ZodTypeAny, {
            ascending?: string[];
            descending?: string[];
        }, {
            ascending?: string[];
            descending?: string[];
        }>>>;
        in: z.ZodOptional<z.ZodString>;
        before: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
        after: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
        limitedTo: z.ZodOptional<z.ZodNumber>;
    }, "to">, "strip", z.ZodTypeAny, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>>>>;
    set: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodObject<{
        with: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>, z.ZodEffects<z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, Record<string, any>[], Record<string, any>[]>]>>;
        where: z.ZodOptional<z.ZodUnion<[z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, z.ZodArray<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, "many">, z.ZodAny]>>;
        including: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        excluding: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        orderedBy: z.ZodOptional<z.ZodOptional<z.ZodObject<{
            ascending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            descending: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, "strip", z.ZodTypeAny, {
            ascending?: string[];
            descending?: string[];
        }, {
            ascending?: string[];
            descending?: string[];
        }>>>;
        in: z.ZodOptional<z.ZodString>;
        before: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
        after: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodNull]>>;
        limitedTo: z.ZodOptional<z.ZodNumber>;
        to: z.ZodEffects<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodNull, z.ZodAny]>>, Record<string, any>, Record<string, any>>;
    }, "strip", z.ZodTypeAny, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
        to?: Record<string, any>;
    }, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
        to?: Record<string, any>;
    }>>>;
}, "strip", z.ZodTypeAny, {
    count?: Record<string, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>;
    create?: Record<string, {
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
        with?: Record<string, any>;
    }>;
    drop?: Record<string, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>;
    get?: Record<string, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>;
    set?: Record<string, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
        to?: Record<string, any>;
    }>;
}, {
    count?: Record<string, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>;
    create?: Record<string, {
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
        with?: Record<string, any>;
    }>;
    drop?: Record<string, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>;
    get?: Record<string, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>;
    set?: Record<string, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
        to?: Record<string, any>;
    }>;
}>;
type Query = z.infer<typeof QuerySchema>;
type BindToArray<T, R> = {
    [K in keyof T]: T[K] extends Array<infer U> ? Array<U> & R : T[K];
};
type Results<T> = T extends [] ? [] : T extends [infer First, ...infer Rest] ? Rest extends unknown ? First extends Promise<infer U> ? [U] : BindToArray<[
    First,
    ...Rest
], {
    moreBefore?: string;
    moreAfter?: string;
}> : Array<First> : T extends Promise<infer U> ? [U] : [T];

declare const StoredObjectSchema: z.ZodObject<{
    key: z.ZodString;
    src: z.ZodString;
    placeholder: z.ZodNullable<z.ZodObject<{
        base64: z.ZodNullable<z.ZodString>;
    }, "strip", z.ZodTypeAny, {
        base64?: string;
    }, {
        base64?: string;
    }>>;
    meta: z.ZodUnion<[z.ZodObject<{
        size: z.ZodNumber;
        type: z.ZodString;
    }, "strip", z.ZodTypeAny, {
        size?: number;
        type?: string;
    }, {
        size?: number;
        type?: string;
    }>, z.ZodObject<{
        type: z.ZodString;
        size: z.ZodNumber;
        width: z.ZodNumber;
        height: z.ZodNumber;
    }, "strip", z.ZodTypeAny, {
        type?: string;
        size?: number;
        width?: number;
        height?: number;
    }, {
        type?: string;
        size?: number;
        width?: number;
        height?: number;
    }>]>;
}, "strip", z.ZodTypeAny, {
    key?: string;
    src?: string;
    placeholder?: {
        base64?: string;
    };
    meta?: {
        size?: number;
        type?: string;
    } | {
        type?: string;
        size?: number;
        width?: number;
        height?: number;
    };
}, {
    key?: string;
    src?: string;
    placeholder?: {
        base64?: string;
    };
    meta?: {
        size?: number;
        type?: string;
    } | {
        type?: string;
        size?: number;
        width?: number;
        height?: number;
    };
}>;
type StoredObject = z.infer<typeof StoredObjectSchema>;
declare const StorableObjectSchema: z.ZodObject<{
    query: z.ZodObject<{
        index: z.ZodNumber;
        type: z.ZodEnum<["set", "create"]>;
    }, "strip", z.ZodTypeAny, {
        index?: number;
        type?: "set" | "create";
    }, {
        index?: number;
        type?: "set" | "create";
    }>;
    schema: z.ZodString;
    field: z.ZodString;
    value: z.ZodAny;
    contentType: z.ZodString;
    reference: z.ZodNullable<z.ZodObject<{
        key: z.ZodString;
        src: z.ZodString;
        placeholder: z.ZodNullable<z.ZodObject<{
            base64: z.ZodNullable<z.ZodString>;
        }, "strip", z.ZodTypeAny, {
            base64?: string;
        }, {
            base64?: string;
        }>>;
        meta: z.ZodUnion<[z.ZodObject<{
            size: z.ZodNumber;
            type: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            size?: number;
            type?: string;
        }, {
            size?: number;
            type?: string;
        }>, z.ZodObject<{
            type: z.ZodString;
            size: z.ZodNumber;
            width: z.ZodNumber;
            height: z.ZodNumber;
        }, "strip", z.ZodTypeAny, {
            type?: string;
            size?: number;
            width?: number;
            height?: number;
        }, {
            type?: string;
            size?: number;
            width?: number;
            height?: number;
        }>]>;
    }, "strip", z.ZodTypeAny, {
        key?: string;
        src?: string;
        placeholder?: {
            base64?: string;
        };
        meta?: {
            size?: number;
            type?: string;
        } | {
            type?: string;
            size?: number;
            width?: number;
            height?: number;
        };
    }, {
        key?: string;
        src?: string;
        placeholder?: {
            base64?: string;
        };
        meta?: {
            size?: number;
            type?: string;
        } | {
            type?: string;
            size?: number;
            width?: number;
            height?: number;
        };
    }>>;
}, "strip", z.ZodTypeAny, {
    query?: {
        index?: number;
        type?: "set" | "create";
    };
    schema?: string;
    field?: string;
    value?: any;
    contentType?: string;
    reference?: {
        key?: string;
        src?: string;
        placeholder?: {
            base64?: string;
        };
        meta?: {
            size?: number;
            type?: string;
        } | {
            type?: string;
            size?: number;
            width?: number;
            height?: number;
        };
    };
}, {
    query?: {
        index?: number;
        type?: "set" | "create";
    };
    schema?: string;
    field?: string;
    value?: any;
    contentType?: string;
    reference?: {
        key?: string;
        src?: string;
        placeholder?: {
            base64?: string;
        };
        meta?: {
            size?: number;
            type?: string;
        } | {
            type?: string;
            size?: number;
            width?: number;
            height?: number;
        };
    };
}>;
type StorableObject = z.infer<typeof StorableObjectSchema>;
type StorableObjectValue = File | ReadableStream | Buffer;

interface UploadOptions {
    endpoint?: string;
}
/**
 * ## 🚧 For internal use only! 🚧
 *
 * Process `StorableObjectValue`s contained in queries.
 * @param queries Array of queries that contain `StorableObjectValue`s.
 * @param token Token used to authenticate the request.
 * @param options Optional object containing options for the upload request.
 * @returns Queries with `StorableObjectValue`s replaced by `StoredObject`s.
 */
declare const processStorableObjects: (queries: Query[], token: string, options?: UploadOptions) => Promise<Query[]>;

/**
 * Utility type to make all properties of an object optional.
 */
type RecursivePartial<T> = {
    [K in keyof T]?: T[K] extends Array<infer U> ? Array<RecursivePartial<U>> : T[K] extends object ? RecursivePartial<T[K]> : T[K];
};
/**
 * Utility type to prettify the type of an object.
 * @see https://twitter.com/mattpocockuk/status/1622730173446557697
 */
type Prettify<T> = T extends Array<unknown> ? T : {
    [K in keyof T]: T[K];
} & {};

type Fetcher = typeof fetch;

type QueryProcessingOptions = {
    /**
     * Allows for specifying a custom HTTP endpoint that the provided queries
     * should be submitted to.
     */
    endpoint?: string;
    /**
     * Allows for specifying a custom replacement for the native JavaScript
     * `fetch` function used to make network requests for submitting queries.
     */
    fetcher?: Fetcher;
    /** ## 🚧 For internal use only! 🚧 */
    dataSelector?: string;
};

declare namespace RONIN {
    export type Json = string | number | boolean | null | Array<Json> | {
        [T in string]: Json;
    };
    export type RecursiveNullish<T> = T extends Array<any> ? {
        [K in keyof T]?: RecursiveNullish<T[K]> | null;
    } | null | undefined : T extends Date ? T | null | undefined : T extends Record<string, any> | RONIN.RoninRecord ? {
        [K in keyof T]?: RecursiveNullish<T[K]> | null;
    } : T | null | undefined;
    export interface RoninMetadata {
        createdAt: Date;
        createdBy: `acc_${string}` | Record<string, any>;
        deletedAt: Date | null;
        deletedBy: `acc_${string}` | Record<string, any> | null;
        locked: boolean;
        status: 'draft' | 'published' | 'archived';
        updatedAt: Date;
        updatedBy: `acc_${string}` | Record<string, any>;
    }
    export interface RoninRecord<TIdPrefix extends string = 'rec'> {
        id: `${TIdPrefix}_${string}`;
        ronin: RoninMetadata;
    }
    interface AllSubFilters<T> {
        is: T | Array<T> | null;
        isNot: T | Array<T> | null;
        contains: string | Exclude<T | Array<T>, null>;
        endsWith: string | Exclude<T | Array<T>, null>;
        startsWith: string | Exclude<T | Array<T>, null>;
        isGreaterThan: T;
        isLessThan: T;
    }
    type SubFilter<T> = Prettify<T extends number ? Pick<Partial<AllSubFilters<T>>, 'isGreaterThan' | 'isLessThan' | 'is'> : T extends string ? Pick<Partial<AllSubFilters<T>>, 'contains' | 'endsWith' | 'is' | 'isNot' | 'startsWith'> : T extends boolean ? Pick<Partial<AllSubFilters<T>>, 'is'> : T extends Date ? Pick<Partial<AllSubFilters<T>>, 'isGreaterThan' | 'isLessThan' | 'is' | 'isNot'> : never>;
    type Where<TSchema extends Record<string, any>> = {
        [TKey in keyof TSchema]: SubFilter<TSchema[TKey]> | Where<TSchema[TKey]> | Array<SubFilter<TSchema[TKey]> | Where<TSchema[TKey]>>;
    };
    type With<TSchema extends Record<string, any>> = {
        [TKey in keyof TSchema]: TSchema[TKey] | Array<TSchema[TKey]>;
    };
    type AllFields<TSchema> = `ronin.${keyof RoninMetadata}` | Exclude<keyof TSchema, 'ronin'>;
    interface OrderedBy<TSchema> {
        /** Order the resulting records in descending order using a specific field. */
        descending: Array<AllFields<TSchema>>;
        /** Order the resulting records in ascending order using a specific field. */
        ascending: Array<AllFields<TSchema>>;
    }
    type To<TSchema extends Record<string, any>> = With<TSchema>;
    export type SchemaSlugKey = keyof RONIN.Counter | keyof RONIN.Creator | keyof RONIN.Dropper | keyof RONIN.Getter | keyof RONIN.Setter;
    export interface Filter<TSchema extends (Record<string, any> & RoninRecord) | Array<Record<string, any> & RoninRecord>, TSlug extends SchemaSlugKey, TVariant extends string = string> {
        /** Perform specific matching actions (such as "is", "contains", or "startsWith") on the fields of a record. */
        where: RecursiveNullish<Where<TSchema>> | Array<RecursiveNullish<Where<TSchema>>>;
        /** Perform "is" matching actions on the fields of a record. */
        with: RecursiveNullish<With<TSchema>> | Array<RecursiveNullish<With<TSchema>>>;
        /** Order the resulting records using a specific field. */
        orderedBy: RecursivePartial<OrderedBy<TSchema>>;
        /** Resolve records in a specific variant. */
        in: TVariant;
        /** Resolve the records associated with certain fields of type "Record". */
        including: Array<RecursivePartial<RONIN.Includes[TSlug]> | `ronin.${keyof Pick<RoninMetadata, 'createdBy' | 'updatedBy'>}`>;
        /**
         * Set the maximum number of records to be retrieved before a subsequent page must be requested.
         *
         * The default is `20` and the maximum is `1000`.
         */
        limitedTo: number;
        /**
         * Retrieve the previous page of records.
         *
         * Consumes the value of `records.moreBefore` (defined on the array of records returned by a previous query).
         *
         * The page size can be customized using `limitedTo` and defaults to `20`.
         */
        before: number;
        /**
         * Retrieve the next page of records.
         *
         * Consumes the value of `records.moreAfter` (defined on the array of records returned by a previous query).
         *
         * The page size can be customized using `limitedTo` and defaults to `20`.
         */
        after: number;
    }
    export interface FilterAndMutate<TSchema extends (Record<string, any> & RoninRecord) | Array<Record<string, any> & RoninRecord>, TSlug extends SchemaSlugKey, TVariant extends string = never> extends Filter<TSchema, TSlug, TVariant> {
        /** Perform mutations on the fields of a record or add new fields to it. */
        to: RecursiveNullish<To<TSchema>>;
    }
    export interface Includes extends Record<SchemaSlugKey, string> {
    }
    export interface Counter extends Record<string, Partial<Filter<Record<string, any> & RoninRecord, never>>> {
    }
    export interface Creator extends Record<string, Partial<Filter<Record<string, any> & RoninRecord, never>>> {
    }
    export interface Dropper extends Record<string, Partial<Filter<Record<string, any> & RoninRecord, never>>> {
    }
    export interface Getter extends Record<string, Partial<Filter<Record<string, any> & RoninRecord, never>>> {
    }
    export interface Setter extends Record<string, Partial<FilterAndMutate<Record<string, any> & RoninRecord, never>>> {
    }
    export {};
}

interface RunScratchpadOptions {
    /**
     * Object containing data hooks for defined schemas.
     */
    hooks?: Record<string, unknown>;
    /**
     * Token used to authenticate against RONIN. By default,
     * `process.env.RONIN_TOKEN` will be used.
     */
    token?: string;
    /**
     * Allows for extending the lifetime of the edge worker invocation until the
     * provided promise has been resolved.
     */
    waitUntil?: (promise: Promise<unknown>) => void;
    /**
     * ## 🚧 For internal use only! 🚧
     *
     * Allows for specifying custom options used for processing queries.
     */
    queryProcessingOptions?: QueryProcessingOptions;
}
interface ScratchPadActions {
    /**
     * Retrieve existing records.
     *
     * Read more at https://docs.ronin.co/queries
     *
     * ```js
     * // Simple Example
     * get.account.with.handle = "juri";
     *
     * // Advanced Example
     * get.accounts = {
     *   where: {
     *     role: {
     *       is: "ADMIN" // 👈🏻 Match specific fields
     *     }
     *   }
     *   orderedBy: {
     *     ascending: ["createdAt"]
     *   },
     *   include: ["roles"], // 👈🏻 Resolve nested records
     * }
     * ```
     */
    get: RONIN.Getter;
    /**
     * Modify existing records.
     *
     * Read more at https://docs.ronin.co/queries
     *
     * ```js
     * // Example
     * set.account = {
     *   with: {
     *     handle: "juri",
     *   },
     *   to: {
     *     verified: true,
     *   },
     * }
     * ```
     */
    set: RONIN.Setter;
    /**
     * Create a new record.
     *
     * Read more at https://docs.ronin.co/queries
     *
     * ```js
     * // Example
     * create.account.with = {
     *   handle: "juri",
     *   verified: false,
     * }
     * ```
     */
    create: RONIN.Creator;
    /**
     * Drop existing records.
     *
     * Read more at https://docs.ronin.co/queries
     *
     * ```js
     * // Example
     * drop.accounts.where.handle.isNot = "juri",
     * ```
     */
    drop: RONIN.Dropper;
    /**
     * Count matching records.
     *
     * Read more at https://docs.ronin.co/queries
     *
     * ```js
     * // Example:
     * count.accounts.where.verified.is = true;
     * ```
     */
    count: RONIN.Counter;
}
type ScratchPad = (actions: ScratchPadActions) => void | Promise<void>;
type ScratchPadFactory = <T>(scratchPad: ScratchPad) => Promise<Results<T>>;

type FilteredHookQuery<TQuery extends FullQueryInstructions, TType extends QueryType> = RecursivePartial<TQuery> & Pick<TQuery, TType extends 'count' ? never : TType extends 'create' ? 'with' : TType extends 'get' ? never : TType extends 'set' ? 'to' : TType extends 'drop' ? never : never>;
type BeforeHookHandler<TType extends QueryType, TQuery extends FilteredHookQuery<FullQueryInstructions, TType> = FilteredHookQuery<FullQueryInstructions, TType>> = (query: TQuery, multipleRecords: boolean) => TQuery | Promise<TQuery>;
type DuringHookHandler<TType extends QueryType, TSchema = unknown> = (query: FilteredHookQuery<FullQueryInstructions, TType>, multipleRecords: boolean) => TSchema | Promise<TSchema>;
type AfterHookHandler<TType extends QueryType, TSchema = unknown> = (query: FilteredHookQuery<FullQueryInstructions, TType>, multipleRecords: boolean, result: TSchema) => void | Promise<void>;
type HookType = 'before' | 'during' | 'after';
type Hook<TStage extends HookType, TType extends QueryType, TSchema extends TStage extends 'before' ? never : unknown = never> = TStage extends 'before' ? BeforeHookHandler<TType> : TStage extends 'during' ? DuringHookHandler<TType, TSchema> : TStage extends 'after' ? AfterHookHandler<TType, TSchema> : never;
type BeforeHook<TType extends QueryType> = Hook<'before', TType>;
type DuringHook<TType extends QueryType, TSchema = unknown> = Hook<'during', TType, TSchema>;
type AfterHook<TType extends QueryType, TSchema = unknown> = Hook<'after', TType, TSchema>;
type BeforeCountHook = BeforeHook<'count'>;
type BeforeCreateHook = BeforeHook<'create'>;
type BeforeDropHook = BeforeHook<'drop'>;
type BeforeGetHook = BeforeHook<'get'>;
type BeforeSetHook = BeforeHook<'set'>;
type CountHook<TSchema = unknown> = DuringHook<'count', TSchema>;
type CreateHook<TSchema = unknown> = DuringHook<'create', TSchema>;
type DropHook<TSchema = unknown> = DuringHook<'drop', TSchema>;
type GetHook<TSchema = unknown> = DuringHook<'get', TSchema>;
type SetHook<TSchema = unknown> = DuringHook<'set', TSchema>;
type AfterCountHook<TSchema = unknown> = AfterHook<'count', TSchema>;
type AfterCreateHook<TSchema = unknown> = AfterHook<'create', TSchema>;
type AfterDropHook<TSchema = unknown> = AfterHook<'drop', TSchema>;
type AfterGetHook<TSchema = unknown> = AfterHook<'get', TSchema>;
type AfterSetHook<TSchema = unknown> = AfterHook<'set', TSchema>;

/**
 * Transform a given `ScratchPad` into `Queries` (array) which can be passed to RONIN.
 * @param scratchPad `ScratchPad` to get executable `Queries` from.
 * @returns `Queries` which will be passed to RONIN.
 */
declare const getQueriesFromScratchPad: (scratchPad: ScratchPad) => Promise<Query[]>;

declare const runQueries: <T>(queries: {
    count?: Record<string, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>;
    create?: Record<string, {
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
        with?: Record<string, any>;
    }>;
    drop?: Record<string, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>;
    get?: Record<string, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
    }>;
    set?: Record<string, {
        with?: Record<string, any> | Record<string, any>[];
        where?: any;
        including?: string[];
        excluding?: string[];
        orderedBy?: {
            ascending?: string[];
            descending?: string[];
        };
        in?: string;
        before?: string;
        after?: string;
        limitedTo?: number;
        to?: Record<string, any>;
    }>;
}[], options?: RunScratchpadOptions) => Promise<Results<T>>;

/**
 * Execute queries on RONIN.
 *
 * @param config If a scratchpad is passed as the first argument, this can be
 * optional config for it.
 *
 * @returns A function for running scratchpads.
 */
declare function handleScratchPadOrConfig(config?: RunScratchpadOptions): ScratchPadFactory;
/**
 * Execute queries on RONIN.
 *
 * @param input A scratchpad containing queries, or config for creating a factory
 * for running scratchpads.
 * @param config If a scratchpad is passed as the first argument, this can be
 * optional config for it.
 *
 * @returns The results of the queries in the scratchpad.
 */
declare function handleScratchPadOrConfig<T = [unknown]>(scratchPad: ScratchPad, config?: RunScratchpadOptions): Promise<Results<T>>;

export { AfterCountHook, AfterCreateHook, AfterDropHook, AfterGetHook, AfterHookHandler, AfterSetHook, BeforeCountHook, BeforeCreateHook, BeforeDropHook, BeforeGetHook, BeforeHookHandler, BeforeSetHook, CountHook, CountQuery, CountQueryInstructions, CreateHook, CreateQuery, CreateQueryInstructions, DropHook, DropQuery, DropQueryInstructions, DuringHookHandler, GetHook, GetQuery, GetQueryInstructions, Query, QueryInstruction, QueryType, RONIN, Results, RunScratchpadOptions, ScratchPad, ScratchPadActions, SetHook, SetQuery, SetQueryInstructions, StorableObject, StorableObjectValue, StoredObject, handleScratchPadOrConfig as default, getQueriesFromScratchPad, processStorableObjects as processReadables, runQueries };
